<* WOFF + *>
IMPLEMENTATION MODULE StandardSound;
(* Needed for sound support *)
IMPORT SYSTEM;
IMPORT Windows;

FROM IO IMPORT RdKey, WrStr, WrCard, WrLn, WrInt, WrChar, WrReal;
FROM Lib IMPORT Delay;

(* STEP 2: specify here the folder of your sound files *)
CONST
	SOUND_FILES_FOLDER = "Sound//"; (* FOLDER OF SOUND FILES !!!!!!!!!! *)
TYPE
	SoundRc = RECORD
			fileName : ARRAY [1..100] OF CHAR;
			soundFlag : CARDINAL;
		  END;	

		
VAR
	gActive : BOOLEAN; (* sound is working *)
	gSoundList : ARRAY SoundEventEn OF SoundRc;

  (* necessary procedures *)
  PROCEDURE MinCard(c1, c2: CARDINAL): CARDINAL;
  BEGIN
    IF c1 <= c2 THEN
      RETURN c1;
    ELSE
      RETURN c2;
    END;
  END MinCard;

  PROCEDURE StrLength(str: ARRAY OF CHAR): CARDINAL;
    VAR i : CARDINAL;
  BEGIN
    i := 0;
    WHILE (str[i] # CHR(0)) AND (i < HIGH(str)) DO
      INC(i);
    END;
    RETURN i;
  END StrLength;

  PROCEDURE StrCopy(VAR strTo : ARRAY OF CHAR; strFrom: ARRAY OF CHAR);
    VAR i: CARDINAL;
  BEGIN
    FOR i := 0 TO MinCard(HIGH(strTo), HIGH(strFrom)) DO
      strTo[i] := strFrom[i];
    END;
  END StrCopy;

  PROCEDURE StrConcatenate(VAR strTo : ARRAY OF CHAR; strFrom: ARRAY OF CHAR);
    VAR i, l: CARDINAL;
  BEGIN
    l := StrLength(strTo);
    FOR i := 0 TO MinCard(HIGH(strTo) - l, HIGH(strFrom)) DO
      strTo[l + i] := strFrom[i];
    END;
  END StrConcatenate;

  (* Ticker tape display emulation *)
  PROCEDURE TickerTape (txt : ARRAY OF CHAR; length : CARDINAL; time : REAL);
  VAR
	i, j : CARDINAL;
  BEGIN

  WrStr(txt);

  FOR i := 0 TO length DO
	Delay(VAL(CARDINAL, time * 1000.0));
	WrChar(CHR(13));
	FOR j := 1 TO i DO
		WrChar(' ');
	END;
	FOR j := 0 TO HIGH(txt) DO
		WrChar(txt[j]);
	END;
  END;
	
  END TickerTape;

	
(* Play the sound associated with the given SoundEventEn *)
PROCEDURE PlaySoundEvent(e: SoundEventEn);
VAR
	string : ARRAY [1..100] OF CHAR;
BEGIN
IF NOT gActive THEN
	RETURN; (* No sounds -> no use *)
END;

(* Play the sound *)

StrCopy(string, SOUND_FILES_FOLDER);
StrConcatenate(string, gSoundList[e].fileName);

IF (NOT Windows.PlaySound (SYSTEM.ADR(string), NIL, gSoundList[e].soundFlag)) THEN
	WrStr("Sound ERROR : it seems it was not possible to play the sound");
	WrLn;
	WrStr("		     file need here! "); WrStr(gSoundList[e].fileName);
	WrLn;
	WrStr("		     Check whether you have to file AND it is at the good place");
	WrLn;
END;	

END PlaySoundEvent;


(* Initialize the different sound settings *)
PROCEDURE InitSound(asynchronousSound: BOOLEAN) : BOOLEAN;	
CONST
	OFFSET = 10;
	INTERVAL = 0.02;
	STD_FLAGS = Windows.SND_FILENAME;
	XTR_FLAGS = Windows.SND_FILENAME + Windows.SND_NOSTOP;
VAR
	string : ARRAY [1..100] OF CHAR;
	i : CARDINAL;
	e : SoundEventEn;
	soundFlag : CARDINAL;
BEGIN

(* Is asynchronous sound requested *)
IF (asynchronousSound) THEN
	soundFlag := Windows.SND_ASYNC;
ELSE
	soundFlag := Windows.SND_SYNC;
END;
(*WrLn;
WrStr("You should here sound now, this to check whether sound works on your system..."); WrLn;
WrLn; *)

StrCopy(string, SOUND_FILES_FOLDER);
StrConcatenate(string, "soundcheck.wav");
(* Play the test sound here *)
gActive := Windows.PlaySound (SYSTEM.ADR(string), NIL, Windows.SND_FILENAME + Windows.SND_ASYNC);

(* Check whether sound works *)
IF (NOT gActive) THEN
	(*WrStr("Geen geluid op uw systeem..."); WrLn;
	WrLn;*)

	RETURN gActive;
ELSE
(*	WrLn; WrLn; WrLn;
	TickerTape("                ", OFFSET, INTERVAL); WrLn;
	TickerTape("                ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	TickerTape("                        ", OFFSET, INTERVAL); WrLn;
	TickerTape("                        ", OFFSET, INTERVAL); WrLn;
	TickerTape("                      ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	TickerTape("                          ", OFFSET, INTERVAL); WrLn;
	WrLn;
	TickerTape("", OFFSET, INTERVAL); WrLn;
	TickerTape("", OFFSET, INTERVAL); WrLn;
	WrLn; WrLn;*)

	(*WrStr("Uw geluid werkt!"); WrLn;   *)
END;

(* STEP 3: associate sound events with wav-files *)

(* Initialize the sound arrays *)

gSoundList[Gedaan].fileName := "GameOver.wav";
gSoundList[Gedaan].soundFlag := STD_FLAGS + soundFlag;

gSoundList[BijnaDodeMuis].fileName := "Geraakt.wav";
gSoundList[BijnaDodeMuis].soundFlag := STD_FLAGS + soundFlag;

gSoundList[IntroLawaai].fileName := "Intro.wav";
gSoundList[IntroLawaai].soundFlag := STD_FLAGS + soundFlag;

gSoundList[Schieten].fileName := "Schot.wav";
gSoundList[Schieten].soundFlag := STD_FLAGS + soundFlag;

(*gSoundList[GAMEOVER2].fileName := "niveaunihil.wav";
gSoundList[GAMEOVER2].soundFlag := STD_FLAGS + soundFlag;

gSoundList[GAMEOVER3].fileName := "beschaamd.wav";
gSoundList[GAMEOVER3].soundFlag := STD_FLAGS + soundFlag;

gSoundList[GAMEOVER4].fileName := "geldterug.wav";
gSoundList[GAMEOVER4].soundFlag := STD_FLAGS + soundFlag;

gSoundList[IDENTITY1].fileName := "pornomens.wav";
gSoundList[IDENTITY1].soundFlag := STD_FLAGS + soundFlag;

gSoundList[IDENTITY2].fileName := "protput.wav";
gSoundList[IDENTITY2].soundFlag := STD_FLAGS + soundFlag;

gSoundList[IDENTITY3].fileName := "carlakaka.wav";
gSoundList[IDENTITY3].soundFlag := STD_FLAGS + soundFlag;

gSoundList[CREATOR1].fileName := "ballen.wav";
gSoundList[CREATOR1].soundFlag := STD_FLAGS + soundFlag;

gSoundList[CREATOR2].fileName := "nietvoorniks.wav";
gSoundList[CREATOR2].soundFlag := STD_FLAGS + soundFlag;

gSoundList[HIGHSCORE].fileName := "opdewebsite.wav";
gSoundList[HIGHSCORE].soundFlag := STD_FLAGS + soundFlag;


gSoundList[VAST].fileName := "neealain.wav";
gSoundList[VAST].soundFlag := STD_FLAGS + soundFlag;

gSoundList[CHEAT].fileName := "cash.wav";
gSoundList[CHEAT].soundFlag := STD_FLAGS + soundFlag;

gSoundList[WERNER].fileName := "werner.wav";
gSoundList[WERNER].soundFlag := STD_FLAGS + soundFlag;

gSoundList[TIKTAK].fileName := "tiktak.wav";
gSoundList[TIKTAK].soundFlag := STD_FLAGS + soundFlag;


gSoundList[WATERSTART].fileName := "water.wav";
gSoundList[WATERSTART].soundFlag := STD_FLAGS + soundFlag;

gSoundList[WATEREIND].fileName := "drain.wav";
gSoundList[WATEREIND].soundFlag := STD_FLAGS + soundFlag;

gSoundList[EAT_FOOD].fileName := "doughtnuts.wav";
gSoundList[EAT_FOOD].soundFlag := STD_FLAGS + soundFlag;

gSoundList[GET_KILLED].fileName := "bazooka.wav";
gSoundList[GET_KILLED].soundFlag := STD_FLAGS + soundFlag;

gSoundList[TAKE_BONUS].fileName := "aaw_crap.wav";
gSoundList[TAKE_BONUS].soundFlag := STD_FLAGS + soundFlag;

gSoundList[KILL_OTHER].fileName := "doh.wav";
gSoundList[KILL_OTHER].soundFlag := STD_FLAGS + soundFlag;

gSoundList[EXPLODE].fileName := "what_thehell.wav";
gSoundList[EXPLODE].soundFlag := STD_FLAGS + soundFlag;

gSoundList[FUN_SOUND].fileName := "join.wav";
gSoundList[FUN_SOUND].soundFlag := STD_FLAGS + soundFlag;

gSoundList[END_SOUND].fileName := "any_key.wav";
gSoundList[END_SOUND].soundFlag := STD_FLAGS + soundFlag;

gSoundList[KEY_SOUND].fileName := "no_english.wav";
gSoundList[KEY_SOUND].soundFlag := STD_FLAGS + soundFlag;

 more sounds ...
gSoundList[].fileName := "explosio.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "come_to.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "forbidden.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "hogfat.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "exelent.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "special.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "payback.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "animals.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "so_long.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "hastavista.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "killscot.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "splat.wav";
gSoundList[].soundFlag := XTR_FLAGS + soundFlag;

gSoundList[].fileName := "any_key.wav";
gSoundList[].soundFlag := STD_FLAGS + soundFlag;

gSoundList[].fileName := "tuut.wav";
gSoundList[].soundFlag := XTR_FLAGS + soundFlag;*)

RETURN gActive;
END InitSound;

END StandardSound.